﻿using Grasshopper.GUI;
using Grasshopper.Kernel;
using Rhino;
using System;
using System.Globalization;
using System.Windows.Forms;
namespace MenuInput
{
    public class MenuInputComponent : GH_Component
    {
        private double _number;
        private string _text;
        public MenuInputComponent() : base("MenuInput", "Nickname", "Description", "Category", "Subcategory") { }
        protected override void RegisterInputParams(GH_InputParamManager pManager) { }
        protected override void RegisterOutputParams(GH_OutputParamManager pManager)
        {
            pManager.AddNumberParameter("O", "O", "O", GH_ParamAccess.item);
        }
        protected override void SolveInstance(IGH_DataAccess DA)
        {
            DA.SetData(0, _number);
        }
        public override void AppendAdditionalMenuItems(ToolStripDropDown menu)
        {
            var setInt = Menu_AppendItem(menu, "Set Number");
            var item = Menu_AppendTextItem(setInt.DropDown, _number.ToString(CultureInfo.InvariantCulture), null, TextChanged, true);
            setInt.DropDownItems[1].Click += CommitChanges;
        }
        private void TextChanged(GH_MenuTextBox sender, string newText)
        {
            _text = newText;
        }
        private void CommitChanges(object sender, EventArgs e)
        {
            if (RhinoMath.EpsilonEquals(Convert.ToDouble(_text), _number, double.Epsilon)) return;
            _number = Convert.ToDouble(_text);
            ExpireSolution(true);
        }
        protected override System.Drawing.Bitmap Icon => null;
        public override Guid ComponentGuid => new Guid("d2bc99d5-36b1-4139-b42d-f21ac50d3a90");
    }
}